Attribute VB_Name = "Global"
Option Explicit

Private Const WM_CLOSE As Long = &H10&
Private Const WM_TIMER As Long = &H113&

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type Msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageA" (lpMsg As Msg) As Long
Private Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As Msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Private Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long

Private mIDTimer1 As Long
Private mIDTimer2 As Long


Public Sub Main()
Dim aMsg As Msg
    If App.PrevInstance Then
        MessageBox 0&, "Applikation krs redan!", App.Title, 0&
    Else
        mIDTimer1 = SetTimer(0&, 0&, 5000, AddressOf TimerProc)
        mIDTimer2 = SetTimer(0&, 0&, 10000, AddressOf TimerProc)
        
        Do While GetMessage(aMsg, 0&, 0&, 0&)
            Select Case aMsg.message
            Case WM_CLOSE
                MessageBox 0&, "WM_CLOSE", "WM_CLOSE", vbOK Or vbDefaultButton2
                Exit Do
            Case WM_TIMER
                If DispatchMessage(aMsg) = 1000 Then
                    Exit Do
                End If
            Case Else
                DispatchMessage aMsg
            End Select
        Loop
        
        KillTimer 0&, mIDTimer1
        KillTimer 0&, mIDTimer2
    End If
End Sub

Public Function TimerProc(ByVal hwnd As Long, ByVal uMSG As Long, ByVal nIDEvent As Long, ByVal dwTime As Long) As Long
Static Dialog As Boolean
Static Antal1 As Long
Static Antal2 As Long
    Select Case nIDEvent
    Case mIDTimer1
        Antal1 = Antal1 + 1
    Case mIDTimer2
        Antal2 = Antal2 + 1
    End Select
    
    If Dialog Then
    Else
        Dialog = True
        Select Case MessageBox(0&, "Antal anrop Timer1: " & Antal1 & vbCrLf & "Antal anrop Timer2: " & Antal2 & vbCrLf & vbCrLf & "Vill du avsluta?", "TimerProc: " & nIDEvent, vbYesNo Or vbDefaultButton2)
        Case vbYes
            TimerProc = 1000
        End Select
        Dialog = False
    End If
End Function
